var fill, readbinary, size;

readbinary = require('./readbinary');

fill = {
  byte: -127,
  char: 0,
  short: -32767,
  int: -2147483647,
  float: 9.969209968386869e+36,
  double: 9.969209968386869e+36
};

size = {
  byte: 1,
  char: 1,
  short: 2,
  int: 4,
  float: 4,
  double: 8
};

module.exports = {
  reader: function(type, fill) {
    var f;
    if (readbinary[type] == null) {
      throw new Error("A reader for " + type + " not found");
    }
    f = readbinary[type];
    if ((fill == null) || type === 'char') {
      return f;
    }
    return function(b, i) {
      var result;
      result = f(b, i);
      if (result === fill) {
        return null;
      }
      return result;
    };
  },
  fill: function(type) {
    if (fill[type] != null) {
      return fill[type];
    }
    throw new Error("No fill found for " + type);
  },
  size: function(type) {
    if (size[type] != null) {
      return size[type];
    }
    throw new Error("No size found for " + type);
  }
};
